#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;



namespace FilterTemplate {

	public ref class SettingsForm : public System::Windows::Forms::Form
	{
	public:
		filtersettings* FilterSetting;
		bool FilterCancelled, init;

	private: 
		System::Windows::Forms::Button^			ButtonApply;
		System::Windows::Forms::Button^			ButtonCancel;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexBorder;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexCheck;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexNew;
		System::Windows::Forms::HScrollBar^		ScrollBarBlobSizeLimit;
		System::Windows::Forms::Label^			label1;
		System::Windows::Forms::Label^			label2;
		System::Windows::Forms::Label^			label3;
		System::Windows::Forms::Label^			label5;
		System::Windows::Forms::Label^			LabelIndexBorder;
		System::Windows::Forms::Label^			LabelIndexCheck;
		System::Windows::Forms::Label^			LabelIndexNew;
		System::Windows::Forms::Label^			LabelBlobSizeLimit;
		System::Windows::Forms::PictureBox^		PictureBoxBorderColor;
		System::Windows::Forms::PictureBox^		PictureBoxCheckColor;
		System::Windows::Forms::PictureBox^		PictureBoxNewColor;
		System::ComponentModel::IContainer^		components;

	public:
		SettingsForm(filtersettings* fs)
		{
			InitializeComponent();

			FilterSetting = fs;
			init = true;

			ScrollBarIndexBorder->Minimum   = 0;
			ScrollBarIndexBorder->Maximum   = 255;
			ScrollBarIndexBorder->Value     = fs->blob_index_border;
			ScrollBarIndexCheck->Minimum    = 0;
			ScrollBarIndexCheck->Maximum    = 255;
			ScrollBarIndexCheck->Value      = fs->blob_index_check;
			ScrollBarIndexNew->Minimum      = 0;
			ScrollBarIndexNew->Maximum      = 255;
			ScrollBarIndexNew->Value        = fs->blob_index_new;
			ScrollBarBlobSizeLimit->Minimum = 10;
			ScrollBarBlobSizeLimit->Maximum = 10000;

			if (fs->blob_index_size_limit < 10)    fs->blob_index_size_limit = 10;
			if (fs->blob_index_size_limit > 10000) fs->blob_index_size_limit = 10000;
			ScrollBarBlobSizeLimit->Value   = fs->blob_index_size_limit;

			init = false;

			Scroll_ValueChanged(nullptr, nullptr);

			FilterCancelled = true;
		}

	protected:

		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->ScrollBarIndexBorder = (gcnew System::Windows::Forms::HScrollBar());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->LabelIndexBorder = (gcnew System::Windows::Forms::Label());
			this->LabelIndexCheck = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarIndexCheck = (gcnew System::Windows::Forms::HScrollBar());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarBlobSizeLimit = (gcnew System::Windows::Forms::HScrollBar());
			this->LabelBlobSizeLimit = (gcnew System::Windows::Forms::Label());
			this->PictureBoxBorderColor = (gcnew System::Windows::Forms::PictureBox());
			this->PictureBoxCheckColor = (gcnew System::Windows::Forms::PictureBox());
			this->PictureBoxNewColor = (gcnew System::Windows::Forms::PictureBox());
			this->LabelIndexNew = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarIndexNew = (gcnew System::Windows::Forms::HScrollBar());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxBorderColor))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxCheckColor))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->BeginInit();
			this->SuspendLayout();
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(91, 196);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(172, 196);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// ScrollBarIndexBorder
			// 
			this->ScrollBarIndexBorder->LargeChange = 1;
			this->ScrollBarIndexBorder->Location = System::Drawing::Point(51, 76);
			this->ScrollBarIndexBorder->Maximum = 255;
			this->ScrollBarIndexBorder->Name = L"ScrollBarIndexBorder";
			this->ScrollBarIndexBorder->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexBorder->TabIndex = 8;
			this->ScrollBarIndexBorder->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexBorder->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->ForeColor = System::Drawing::Color::White;
			this->label2->Location = System::Drawing::Point(48, 63);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(110, 13);
			this->label2->TabIndex = 11;
			this->label2->Text = L"Hatrol szn indexe::";
			// 
			// LabelIndexBorder
			// 
			this->LabelIndexBorder->AutoSize = true;
			this->LabelIndexBorder->ForeColor = System::Drawing::Color::White;
			this->LabelIndexBorder->Location = System::Drawing::Point(304, 80);
			this->LabelIndexBorder->Name = L"LabelIndexBorder";
			this->LabelIndexBorder->Size = System::Drawing::Size(13, 13);
			this->LabelIndexBorder->TabIndex = 14;
			this->LabelIndexBorder->Text = L"0";
			// 
			// LabelIndexCheck
			// 
			this->LabelIndexCheck->AutoSize = true;
			this->LabelIndexCheck->ForeColor = System::Drawing::Color::White;
			this->LabelIndexCheck->Location = System::Drawing::Point(304, 127);
			this->LabelIndexCheck->Name = L"LabelIndexCheck";
			this->LabelIndexCheck->Size = System::Drawing::Size(13, 13);
			this->LabelIndexCheck->TabIndex = 17;
			this->LabelIndexCheck->Text = L"0";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->ForeColor = System::Drawing::Color::White;
			this->label3->Location = System::Drawing::Point(48, 110);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(82, 13);
			this->label3->TabIndex = 16;
			this->label3->Text = L"Blob szn-index:";
			// 
			// ScrollBarIndexCheck
			// 
			this->ScrollBarIndexCheck->LargeChange = 1;
			this->ScrollBarIndexCheck->Location = System::Drawing::Point(51, 123);
			this->ScrollBarIndexCheck->Maximum = 255;
			this->ScrollBarIndexCheck->Name = L"ScrollBarIndexCheck";
			this->ScrollBarIndexCheck->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexCheck->TabIndex = 15;
			this->ScrollBarIndexCheck->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexCheck->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->ForeColor = System::Drawing::Color::White;
			this->label1->Location = System::Drawing::Point(48, 9);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(199, 13);
			this->label1->TabIndex = 18;
			this->label1->Text = L"Blob kifolysnak megengedett mrtke:";
			// 
			// ScrollBarBlobSizeLimit
			// 
			this->ScrollBarBlobSizeLimit->LargeChange = 1;
			this->ScrollBarBlobSizeLimit->Location = System::Drawing::Point(51, 22);
			this->ScrollBarBlobSizeLimit->Maximum = 10000;
			this->ScrollBarBlobSizeLimit->Minimum = 10;
			this->ScrollBarBlobSizeLimit->Name = L"ScrollBarBlobSizeLimit";
			this->ScrollBarBlobSizeLimit->Size = System::Drawing::Size(250, 17);
			this->ScrollBarBlobSizeLimit->TabIndex = 19;
			this->ScrollBarBlobSizeLimit->Value = 10;
			this->ScrollBarBlobSizeLimit->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarBlobSizeLimit->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// LabelBlobSizeLimit
			// 
			this->LabelBlobSizeLimit->AutoSize = true;
			this->LabelBlobSizeLimit->ForeColor = System::Drawing::Color::White;
			this->LabelBlobSizeLimit->Location = System::Drawing::Point(304, 26);
			this->LabelBlobSizeLimit->Name = L"LabelBlobSizeLimit";
			this->LabelBlobSizeLimit->Size = System::Drawing::Size(19, 13);
			this->LabelBlobSizeLimit->TabIndex = 20;
			this->LabelBlobSizeLimit->Text = L"10";
			// 
			// PictureBoxBorderColor
			// 
			this->PictureBoxBorderColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxBorderColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxBorderColor->Location = System::Drawing::Point(12, 76);
			this->PictureBoxBorderColor->Name = L"PictureBoxBorderColor";
			this->PictureBoxBorderColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxBorderColor->TabIndex = 21;
			this->PictureBoxBorderColor->TabStop = false;
			// 
			// PictureBoxCheckColor
			// 
			this->PictureBoxCheckColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxCheckColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxCheckColor->Location = System::Drawing::Point(12, 123);
			this->PictureBoxCheckColor->Name = L"PictureBoxCheckColor";
			this->PictureBoxCheckColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxCheckColor->TabIndex = 22;
			this->PictureBoxCheckColor->TabStop = false;
			// 
			// PictureBoxNewColor
			// 
			this->PictureBoxNewColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxNewColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxNewColor->Location = System::Drawing::Point(12, 166);
			this->PictureBoxNewColor->Name = L"PictureBoxNewColor";
			this->PictureBoxNewColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxNewColor->TabIndex = 26;
			this->PictureBoxNewColor->TabStop = false;
			// 
			// LabelIndexNew
			// 
			this->LabelIndexNew->AutoSize = true;
			this->LabelIndexNew->ForeColor = System::Drawing::Color::White;
			this->LabelIndexNew->Location = System::Drawing::Point(304, 170);
			this->LabelIndexNew->Name = L"LabelIndexNew";
			this->LabelIndexNew->Size = System::Drawing::Size(13, 13);
			this->LabelIndexNew->TabIndex = 25;
			this->LabelIndexNew->Text = L"0";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->ForeColor = System::Drawing::Color::White;
			this->label5->Location = System::Drawing::Point(48, 153);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(99, 13);
			this->label5->TabIndex = 24;
			this->label5->Text = L"Blob j szn-indexe:";
			// 
			// ScrollBarIndexNew
			// 
			this->ScrollBarIndexNew->LargeChange = 1;
			this->ScrollBarIndexNew->Location = System::Drawing::Point(51, 166);
			this->ScrollBarIndexNew->Maximum = 255;
			this->ScrollBarIndexNew->Name = L"ScrollBarIndexNew";
			this->ScrollBarIndexNew->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexNew->TabIndex = 23;
			this->ScrollBarIndexNew->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexNew->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::SteelBlue;
			this->ClientSize = System::Drawing::Size(337, 231);
			this->Controls->Add(this->PictureBoxNewColor);
			this->Controls->Add(this->LabelIndexNew);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->ScrollBarIndexNew);
			this->Controls->Add(this->PictureBoxCheckColor);
			this->Controls->Add(this->PictureBoxBorderColor);
			this->Controls->Add(this->LabelBlobSizeLimit);
			this->Controls->Add(this->ScrollBarBlobSizeLimit);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->LabelIndexCheck);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->ScrollBarIndexCheck);
			this->Controls->Add(this->LabelIndexBorder);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->ScrollBarIndexBorder);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Kis nyitott foltok eltvoltsa";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxBorderColor))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxCheckColor))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
		System::Void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}

		System::Void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) { this->Close(); }

		System::Void Scroll_Change(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			if (!init)
			{
				FilterSetting->blob_index_border     = ScrollBarIndexBorder->Value;
				FilterSetting->blob_index_check      = ScrollBarIndexCheck->Value;
				FilterSetting->blob_index_new        = ScrollBarIndexNew->Value;
				FilterSetting->blob_index_size_limit = ScrollBarBlobSizeLimit->Value;
			}
			LabelIndexBorder->Text               = ScrollBarIndexBorder->Value.ToString();
			LabelIndexCheck->Text                = ScrollBarIndexCheck->Value.ToString();
			LabelIndexNew->Text                  = ScrollBarIndexNew->Value.ToString();
			LabelBlobSizeLimit->Text             = ScrollBarBlobSizeLimit->Value.ToString();

			int r, g, b, index;

			index = FilterSetting->blob_index_border;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxBorderColor->BackColor     = Color::FromArgb(r, g, b);

			index = FilterSetting->blob_index_check;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxCheckColor->BackColor     = Color::FromArgb(r, g, b);

			index = FilterSetting->blob_index_new;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxNewColor->BackColor     = Color::FromArgb(r, g, b);
		}

		System::Void Scroll_ValueChanged(System::Object^  sender, System::EventArgs^  e) { Scroll_Change(nullptr, nullptr); }
};
}
